// toShare configuration.js
'use strict';
// uses rest, tooltip

const sectionConfiguration = document.querySelector('.configuration');
const tableConfiguration = sectionConfiguration.querySelector('table');
const tbodyConfiguration = sectionConfiguration.querySelector('tbody');
const divEditLayer = document.querySelector('div.edit-layer');
const buttonCancel = divEditLayer.querySelector('button.cancel');
const labelConfigItem = divEditLayer.querySelector('label.config-item');
const inputConfigValue = divEditLayer.querySelector('input.config-value');
const selectConfigColor = divEditLayer.querySelector('select.config-color');
const selectConfigBoolean = divEditLayer.querySelector('select.config-boolean');
const buttonFix = divEditLayer.querySelector('button.fix');
let memoMouseOutside = false;

async function updateConfigurationList(){
	try{
		await atsConfiguration.restGet([
			'Server name',
			'Color style',
			'Account Placeholder',
			'reservation',
			'inoutboard'
		]);
		for(const trTable of tbodyConfiguration.children){
			const td = trTable.querySelectorAll('td');
			trTable.addEventListener('click', onTrConfigurationClick);
			switch(trTable.dataset.key){
			default:
				td[1].innerText = atsConfiguration.valueFromKey(trTable.dataset.key);
				break;
			case 'reservation':
			case 'inoutboard':
				td[1].innerText = atsConfiguration.valueFromKey(trTable.dataset.key)=='true' ? '使用する' : '使用しない';
				break;
			}
		}
		atsConfiguration.reflectionColorStyle();
		atsConfiguration.reflectionIndex()
		atsConfiguration.reflectionInoutboard();
	}catch(e){confirm(e.message);}
}
function onTrConfigurationClick(event){
	event.currentTarget.classList.add('current');
	labelConfigItem.innerText = event.currentTarget.firstElementChild.innerText;
	divEditLayer.dataset.key = event.currentTarget.dataset.key;
	const configValue = atsConfiguration.valueFromKey(divEditLayer.dataset.key);
	buttonFix.disabled = true;
	switch(divEditLayer.dataset.key){
	default:
		inputConfigValue.value = configValue;
		divEditLayer.style.display = 'flex';
		inputConfigValue.select();
		inputConfigValue.focus();
		break;
	case 'Color style':
		inputConfigValue.style.display = 'none';
		selectConfigColor.style.display = 'block';
		selectConfigColor.value = configValue;
		divEditLayer.style.display = 'flex';
		selectConfigColor.focus();
		break;
	case 'reservation':
	case 'inoutboard':
		inputConfigValue.style.display = 'none';
		selectConfigBoolean.style.display = 'block';
		selectConfigBoolean.value = (configValue=='true') ? '使用する' : '使用しない';
		divEditLayer.style.display = 'flex';
		selectConfigBoolean.focus();
		break;
	}
}
function onOutsideClick(event){
	if(event.currentTarget===event.target){
		if(memoMouseOutside){
			onCancel();
		}else{
			 memoMouseOutside = true;
		}
	}else{
		memoMouseOutside = false;
	}
}
function onCancel(){
	atsConfiguration.reflectionColorStyle();
	editLayerClose();
}
function editLayerClose(){
	for(const tbodyTr of tbodyConfiguration.querySelectorAll('tr')){
		if(tbodyTr.classList.contains('current')){tbodyTr.classList.remove('current');}
	}
	divEditLayer.style.display = 'none';
	inputConfigValue.style.display = 'block';
	selectConfigColor.style.display = 'none';
	selectConfigBoolean.style.display = 'none';
}
function onTableModified(){
	buttonFix.disabled = false;
}
function onColorModified(){
	onTableModified();
	atsConfiguration.reflectionColorStyle(selectConfigColor.value);
}
async function onExecute(){
	var configValue = '';
	switch(divEditLayer.dataset.key){
	default:
		configValue = inputConfigValue.value;
		break;
	case 'Color style':
		configValue = selectConfigColor.value;
		break;
	case 'reservation':
	case 'inoutboard':
		configValue = selectConfigBoolean.selectedOptions[0].dataset.bool;
		break;
	}
	await atsConfiguration.restPut(divEditLayer.dataset.key, configValue);
	editLayerClose();
	updateConfigurationList();
}

updateConfigurationList();
divEditLayer.addEventListener('mousedown', onOutsideClick);
divEditLayer.addEventListener('mouseup', onOutsideClick);
buttonCancel.addEventListener('click', onCancel);
inputConfigValue.addEventListener('input', onTableModified);
selectConfigColor.addEventListener('change', onColorModified);
selectConfigBoolean.addEventListener('change', onTableModified);
buttonFix.addEventListener('click', onExecute);
